%define ipvsadm_version 1.24

Name:           net-snmp-lvs-module
Version:        0.0.4
Release:        3%{?dist}
Summary:        net-snmp module to gather information from IPVS

Group:          System Environment/Daemons
License:        GPLv2+
URL:            http://www.linuxvirtualserver.org
Source0:        http://www.loadbalancer.org/download/SNMP/%{name}-%{version}.tar.gz
Source1:        http://www.linuxvirtualserver.org/software/kernel-2.6/ipvsadm-%{ipvsadm_version}.tar.gz
Source2:        COPYING
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  net-snmp-devel
Requires:       net-snmp

# Red Hat uses this patch in RHEL 5
Patch0:		ipvsadm-1.24-kernhdr-1.2.1.patch

# Use the kernel headers provided by the RHEL patch to ipvsadm
Patch1:		net-snmp-lvs-module-0.0.4-kernheaders.patch

# Make RHEL 4 believe this is a 2.6 kernel
Patch2:		net-snmp-lvs-module-0.0.4-2.6-kernel.patch

# Laurentiu Badea's patch to fix the 64 bit int format
Patch3:     lvs-counter64.patch

# Add -fPIC to Makefile CFLAGS. Fixes compile on x86_64
Patch4:     net-snmp-lvs-module-0.0.4-compile.patch

# Memory leak bug fix.
Patch5:     net-snmp-lvs-module-0.0.4-leak_fix-2.patch

# Robin Bowes patch from 2009-09-30, fixing the duplicate registration error
Patch6:     net-snmp-lvs-module-0.0.4-duplicate_registration.patch

# Add -fPIC to Makefile CFLAGS. Fixes compile for libipvs on x86_64
Patch7:     net-snmp-lvs-module-0.0.4-libipvs-Makefile.patch


%description
net-snmpd-lvs-module is a dynamicaly loadable shared object to get the
configuration and some statistical information from the Linux kernel
with IP virtual server support (also known as Linux Virtual Server).

%prep
%setup -q
tar zxf %{SOURCE1}

# patch ipvsadm
pushd ipvsadm-%{ipvsadm_version}
%patch0 -p1
%patch2 -p0
%patch7 -p0
popd

%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch1 -p0
%patch3 -p0

# Copy license file
cp %{SOURCE2} .

%build
# build ipvsadm for libipvs
pushd ipvsadm-%{ipvsadm_version}
make
popd

cp ipvsadm-%{ipvsadm_version}/libipvs/* libipvs/
ln -s ipvsadm-%{ipvsadm_version}/kernheaders kernheaders

make

%install
rm -rf $RPM_BUILD_ROOT

install -m 755 -d $RPM_BUILD_ROOT%{_datadir}/snmp/mibs/
install -m 755 -d $RPM_BUILD_ROOT%{_libdir}
install -m 644 LVS-MIB.txt $RPM_BUILD_ROOT%{_datadir}/snmp/mibs/
install -m 644 OC-MIB.txt $RPM_BUILD_ROOT%{_datadir}/snmp/mibs/
install -m 755 lvs.so $RPM_BUILD_ROOT%{_libdir}/libnetsnmplvs.so


%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%doc README COPYING
%{_datadir}/snmp/mibs/*
%{_libdir}/*

%changelog
* Fri Jan 21 2011 Leon Keijser <keijser@stone-it.com> - 0.0.4-3
- added patches 4 to 7, mainly by loadbalancer.org people

* Mon Oct 06 2008 Jack Neely <jjneely@ncsu.edu> 0.0.4-2
- Add Laurentiu Badea's patch to correct the int types used for ASN_COUNTER64

* Tue Sep 30 2008 Jack Neely <jjneely@ncsu.edu> 0.0.4-1
- Initial Packaging
- Requires kernel includes as well as bits from ipvsadm
- Support on RHEL4 and RHEL5
- x86_64 probably needs some -fPIC patching

